## transmission 4.1.0~beta4+dfsg

=== qt/CMakeLists.txt ===
set_property(GLOBAL PROPERTY AUTOGEN_SOURCE_GROUP "Generated Files")

# https://doc.qt.io/qt-6/macos.html#supported-versions
set(CMAKE_OSX_DEPLOYMENT_TARGET 11)

add_executable(${TR_NAME}-qt WIN32)

target_sources(${TR_NAME}-qt
    PRIVATE
        AboutDialog.cc
        AboutDialog.h
        AccessibleSqueezeLabel.cc
        AccessibleSqueezeLabel.h
        AddData.cc
        AddData.h
        Application.cc
        Application.h
        BaseDialog.h
        ColumnResizer.cc
        ColumnResizer.h
        ComInteropHelper.cc
        ComInteropHelper.h
        CustomVariantType.h
        DBusInteropHelper.cc
        DBusInteropHelper.h
        DetailsDialog.cc
        DetailsDialog.h
        FaviconCache.cc
        FileTreeDelegate.cc
        FileTreeDelegate.h
        FileTreeItem.cc
        FileTreeItem.h
        FileTreeModel.cc
        FileTreeModel.h
        FileTreeView.cc
        FileTreeView.h
        FilterBar.cc
        FilterBar.h
        FilterBarComboBox.cc
        FilterBarComboBox.h
        FilterBarComboBoxDelegate.cc
        FilterBarComboBoxDelegate.h
        Filters.cc
        Filters.h
        Formatter.cc
        Formatter.h
        FreeSpaceLabel.cc
        FreeSpaceLabel.h
        IconCache.cc
        IconCache.h
        IconToolButton.cc
        IconToolButton.h
        InteropHelper.cc
        InteropHelper.h
        InteropObject.cc
        InteropObject.h
        LicenseDialog.cc
        LicenseDialog.h
        main.cc
        MainWindow.cc
        MainWindow.h
        MakeDialog.cc
        MakeDialog.h
        NativeIcon.cc
        $<$<BOOL:${APPLE}>:NativeIconMac.mm>
        NativeIcon.h
        OptionsDialog.cc
        OptionsDialog.h
        PathButton.cc
        PathButton.h
        Prefs.cc
        Prefs.h
        PrefsDialog.cc
        PrefsDialog.h
        RelocateDialog.cc
        RelocateDialog.h
        RpcClient.cc
        RpcClient.h
        RpcQueue.cc
        RpcQueue.h
        Session.cc
        Session.h
        SessionDialog.cc
        SessionDialog.h
        Speed.h
        SqueezeLabel.cc
        SqueezeLabel.h
        StatsDialog.cc
        StatsDialog.h
        StyleHelper.cc
        StyleHelper.h
        Torrent.cc
        Torrent.h
        TorrentDelegate.cc
        TorrentDelegate.h
        TorrentDelegateMin.cc
        TorrentDelegateMin.h
        TorrentFilter.cc
        TorrentFilter.h
        TorrentModel.cc
        TorrentModel.h
        TorrentView.cc
        TorrentView.h
        TrackerDelegate.cc
        TrackerDelegate.h
        TrackerModel.cc
        TrackerModel.h
        TrackerModelFilter.cc
        TrackerModelFilter.h
        Typedefs.h
        Utils.cc
        Utils.h
        VariantHelpers.cc
        VariantHelpers.h
        WatchDir.cc
        WatchDir.h)

tr_allow_compile_if(
    [=[[ENABLE_QT_COM_INTEROP]]=]
        ComInteropHelper.cc
    [=[[ENABLE_QT_DBUS_INTEROP]]=]
        DBusInteropHelper.cc)

target_sources(${TR_NAME}-qt
    PRIVATE
        AboutDialog.ui
        DetailsDialog.ui
        LicenseDialog.ui
        MainWindow.ui
        MakeDialog.ui
        MakeProgressDialog.ui
        OptionsDialog.ui
        PrefsDialog.ui
        RelocateDialog.ui
        SessionDialog.ui
        StatsDialog.ui
        TrackersDialog.ui)

source_group(Ui
    REGULAR_EXPRESSION [[.*\.ui$]])

target_sources(${TR_NAME}-qt
    PRIVATE
        application.qrc)

source_group(Resources
    REGULAR_EXPRESSION [[.*\.qrc$]])

set(LINGUAS
    af
    ca
    da
    de
    el
    en
    es
    eu
    fi
    fr
    he
    hu
    id
    is
    it
    ja
    ka
    kk
    ko
    lt
    nb
    nl
    pl
    pt
    pt_BR
    pt_PT
    ru
    sl
    sv
    tr
    uk
    zh_CN
    zh_TW)

if(ENABLE_NLS)
    set(ENABLED_LINGUAS ${LINGUAS})
else()
    set(ENABLED_LINGUAS)
endif()

set(TS_FILES)
foreach(LANG ${ENABLED_LINGUAS})
    list(APPEND TS_FILES translations/transmission_${LANG}.ts)
endforeach()

if(TS_FILES)
    tr_qt_add_translation(QM_FILES ${TS_FILES})
endif()

target_sources(${TR_NAME}-qt
    PRIVATE
        ${QM_FILES})

if(ENABLE_QT_COM_INTEROP)
    tr_target_idl_files(${TR_NAME}-qt
        transmission-qt.idl)
endif()

target_include_directories(${TR_NAME}-qt
    PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR})

target_link_libraries(${TR_NAME}-qt
    PRIVATE
        ${TR_NAME}
        transmission::qt_impl)

target_compile_definitions(${TR_NAME}-qt
    PRIVATE
        "TRANSLATIONS_DIR=\"${CMAKE_INSTALL_FULL_DATADIR}/${TR_NAME}/translations\""
        QT_NO_CAST_FROM_ASCII
        $<$<BOOL:${ENABLE_QT_COM_INTEROP}>:ENABLE_COM_INTEROP>
        $<$<BOOL:${ENABLE_QT_DBUS_INTEROP}>:ENABLE_DBUS_INTEROP>)

if(MSVC)
    tr_append_target_property(${TR_NAME}-qt LINK_FLAGS "/ENTRY:mainCRTStartup")
endif()

set_target_properties(
    ${TR_NAME}-qt
    PROPERTIES
        AUTOMOC ON
        AUTORCC ON
        AUTOUIC ON)

tr_win32_app_info(${TR_NAME}-qt
    "Transmission Qt Client"
    "${TR_NAME}-qt"
    "${TR_NAME}-qt.exe"
    "${SOURCE_ICONS_DIR}/${TR_NAME}.ico")

install(
    TARGETS ${TR_NAME}-qt
    DESTINATION ${CMAKE_INSTALL_BINDIR})

set(PUBLIC_ICONS
    hicolor_apps_scalable_transmission.svg
    hicolor_apps_scalable_transmission-devel.svg
    hicolor_apps_symbolic_transmission-symbolic.svg)

set(ICON_NAME_REGEX "^([^_]+)_([^_]+)_([^_]+)_(.+)$")
foreach(ICON ${PUBLIC_ICONS})
    string(REGEX REPLACE ${ICON_NAME_REGEX} "\\1/\\3/\\2" ICON_DIR ${ICON})
    string(REGEX REPLACE ${ICON_NAME_REGEX} "\\4" ICON_NAME ${ICON})
    install(
        FILES ${SOURCE_ICONS_DIR}/${ICON}
        DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/${ICON_DIR}/
        RENAME ${ICON_NAME})
endforeach()

if(INSTALL_DOC)
    install(
        FILES ${TR_NAME}-qt.1
        DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
endif()

install(
    FILES transmission-qt.desktop
    DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)

if(ENABLE_NLS)
    install(
        FILES ${QM_FILES}
        DESTINATION ${CMAKE_INSTALL_DATADIR}/${TR_NAME}/translations)
endif()

if(WIN32)
    file(GENERATE
        OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/dist-qt.conf"
        CONTENT "")
    install(
        FILES "${CMAKE_CURRENT_BINARY_DIR}/dist-qt.conf"
        DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}
        RENAME qt.conf)
endif()

=== web/CMakeLists.txt ===
set(WEB_SOURCES
    src/about-dialog.js
    src/action-manager.js
    src/alert-dialog.js
    src/context-menu.js
    src/file-row.js
    src/formatter.js
    src/inspector.js
    src/labels-dialog.js
    src/main.js
    src/move-dialog.js
    src/notifications.js
    src/open-dialog.js
    src/overflow-menu.js
    src/prefs-dialog.js
    src/prefs.js
    src/remote.js
    src/remove-dialog.js
    src/rename-dialog.js
    src/shortcuts-dialog.js
    src/statistics-dialog.js
    src/torrent.js
    src/torrent-row.js
    src/transmission.js
    src/utils.js)

set(WEB_STYLES
    assets/css/transmission-app.scss)

set(WEB_IMAGES
    assets/img/box.svg
    assets/img/chevron-down.svg
    assets/img/chevron-up.svg
    assets/img/file-text.svg
    assets/img/film.svg
    assets/img/folder.svg
    assets/img/horizontal-rule.svg
    assets/img/image.svg
    assets/img/lock-fill.svg
    assets/img/logo.png
    assets/img/magnet.svg
    assets/img/music.svg
    assets/img/package.svg
    assets/img/README.md
    assets/img/router.svg
    assets/img/type.svg
    assets/img/turtle.svg)

add_custom_command(
    OUTPUT
        "${CMAKE_CURRENT_BINARY_DIR}/public_html/transmission-app.css"
        "${CMAKE_CURRENT_BINARY_DIR}/public_html/transmission-app.css.LEGAL.txt"
        "${CMAKE_CURRENT_BINARY_DIR}/public_html/transmission-app.css.map"
        "${CMAKE_CURRENT_BINARY_DIR}/public_html/transmission-app.js"
        "${CMAKE_CURRENT_BINARY_DIR}/public_html/transmission-app.js.LEGAL.txt"
        "${CMAKE_CURRENT_BINARY_DIR}/public_html/transmission-app.js.map"
    WORKING_DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}"
    COMMAND "${CMAKE_COMMAND}" -E copy
        "${CMAKE_CURRENT_SOURCE_DIR}/esbuild.mjs"
        "${CMAKE_CURRENT_SOURCE_DIR}/package-lock.json"
        "${CMAKE_CURRENT_SOURCE_DIR}/package.json"
        "${CMAKE_CURRENT_BINARY_DIR}"
    COMMAND "${CMAKE_COMMAND}" -E copy_directory
        "${CMAKE_CURRENT_SOURCE_DIR}/assets" "assets"
    COMMAND "${CMAKE_COMMAND}" -E copy_directory
        "${CMAKE_CURRENT_SOURCE_DIR}/public_html" "public_html"
    COMMAND "${CMAKE_COMMAND}" -E copy_directory
        "${CMAKE_CURRENT_SOURCE_DIR}/src" "src"
    COMMAND "${NPM}" ci --no-audit --no-fund --no-progress
    COMMAND "${NPM}" run build
    DEPENDS
        ${WEB_SOURCES}
        ${WEB_STYLES}
        ${WEB_IMAGES})

add_custom_target("${TR_NAME}-web"
    ALL
    DEPENDS
        "${CMAKE_CURRENT_BINARY_DIR}/public_html/transmission-app.css"
        "${CMAKE_CURRENT_BINARY_DIR}/public_html/transmission-app.css.LEGAL.txt"
        "${CMAKE_CURRENT_BINARY_DIR}/public_html/transmission-app.css.map"
        "${CMAKE_CURRENT_BINARY_DIR}/public_html/transmission-app.js"
        "${CMAKE_CURRENT_BINARY_DIR}/public_html/transmission-app.js.LEGAL.txt"
        "${CMAKE_CURRENT_BINARY_DIR}/public_html/transmission-app.js.map"
    SOURCES
        ${WEB_SOURCES})

set(TR_WEB_ASSETS ${CMAKE_CURRENT_BINARY_DIR}/public_html PARENT_SCOPE)

=== debian/changelog ===
transmission (4.1.0~beta4+dfsg-1ubuntu1) resolute; urgency=low

  * Merge from Debian unstable. Remaining changes:
  * Remaining changes:
    - d/patches
      + Add patch to revendor libb64 (Closes: #1073005)
    - d/control
      + Drop Build-Depends: libb64-dev
    - d/copyright
      + include copyright information for libb64

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 15 Dec 2025 17:45:00 +0100

transmission (4.1.0~beta4+dfsg-1) unstable; urgency=medium

  * New upstream version 4.1.0~beta4+dfsg
  * drop libfmt probe fix (applied upstream)
  * update use-system-libs.patch with upstream candidate for the change
  * fix build failure with c++20

 -- Alexandre Rossi <niol@zincube.net>  Fri, 05 Dec 2025 10:51:14 +0100

transmission (4.1.0~beta2+dfsg-3ubuntu2) resolute; urgency=medium

  * Rebuild against new libminiupnpc21.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 13 Dec 2025 08:47:00 +0100

transmission (4.1.0~beta2+dfsg-3ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2112079).
    * dropped gtkmm-4.15.0 patch as it was addressed upstream. 
  * Remaining changes:
    - d/patches
      + Add patch to revendor libb64 (Closes: #1073005)
    - d/control
      + Drop Build-Depends: libb64-dev
    - d/copyright
      + include copyright information for libb64


 -- John Chittum <john.chittum@canonical.com>  Tue, 24 Jun 2025 11:58:59 -0400

=== debian/control ===
Source: transmission
Section: net
Priority: optional
Maintainer: Leo Antunes <costela@debian.org>
Uploaders: Alexandre Rossi <niol@zincube.net>,
           Barak A. Pearlmutter <bap@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libayatana-appindicator3-dev,
               libcurl4-openssl-dev | libcurl4-dev | libcurl-dev,
               libevent-dev,
               libgtkmm-4.0-dev (>= 4.11),
               libglibmm-2.68-dev,
               libwolfssl-dev,
               libminiupnpc-dev,
               libnatpmp-dev,
               libnotify-dev,
               libssl-dev,
               libfast-float-dev,
               libfmt-dev,
               libgtest-dev,
               libdeflate-dev,
               libpsl-dev,
               libutfcpp-dev,
               libsystemd-dev [linux-any],
               qt6-base-dev,
               qt6-tools-dev,
               qt6-tools-dev-tools,
               rapidjson-dev,
               libqt6svg6-dev,
               zlib1g-dev,
               esbuild,
               node-fast-deep-equal,
               rsass,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian/transmission
Vcs-Git: https://salsa.debian.org/debian/transmission.git
Homepage: https://transmissionbt.com/

Package: transmission
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: transmission-common (>= ${binary:Version}),
         transmission-gtk (>= ${binary:Version}) | transmission-qt (>= ${binary:Version}) | transmission-cli (>= ${binary:Version}),
         ${misc:Depends}
Description: lightweight BitTorrent client
 Transmission is a set of lightweight BitTorrent clients (in GUI, CLI
 and daemon form). All its incarnations feature a very simple, intuitive
 interface on top on an efficient, cross-platform back-end.
 .
 This is just a metapackage depending on one of the front-end
 alternatives

Package: transmission-common
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}
Description: lightweight BitTorrent client (common files)
 Transmission is a set of lightweight BitTorrent clients (in GUI, CLI
 and daemon form). All its incarnations feature a very simple, intuitive
 interface on top on an efficient, cross-platform back-end.
 .
 This package contains the common files for the different transmission
 versions.

Package: transmission-cli
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: transmission-common (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: transmission-daemon (= ${binary:Version}),
          transmission-gtk (= ${binary:Version})
Description: lightweight BitTorrent client (command line programs)
 Transmission is a set of lightweight BitTorrent clients (in GUI, CLI
 and daemon form). All its incarnations feature a very simple, intuitive
 interface on top on an efficient, cross-platform back-end.
 .
 This package contains transmission-remote to interface with
 transmission-daemon, tools to create/edit/inspect torrent files
 and a deprecated stand-alone command-line client.

Package: transmission-gtk
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: transmission-common (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: xdg-utils
Description: lightweight BitTorrent client (GTK+ interface)
 Transmission is a set of lightweight BitTorrent clients (in GUI, CLI
 and daemon form). All its incarnations feature a very simple, intuitive
 interface on top on an efficient, cross-platform back-end.
 .
 This package contains the GTK+ stand-alone client.

Package: transmission-qt
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: transmission-common (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: xdg-utils
Description: lightweight BitTorrent client (Qt interface)
 Transmission is a set of lightweight BitTorrent clients (in GUI, CLI
 and daemon form). All its incarnations feature a very simple, intuitive
 interface on top on an efficient, cross-platform back-end.
 .
 This package contains the Qt stand-alone client.

Package: transmission-daemon
Architecture: any
Pre-Depends: ${misc:Pre-Depends}, adduser
Depends: transmission-common (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: transmission-cli
Suggests: transmission-remote-gtk | transgui | tremotesf
Description: lightweight BitTorrent client (daemon)
 Transmission is a set of lightweight BitTorrent clients (in GUI, CLI
 and daemon form). All its incarnations feature a very simple, intuitive
 interface on top on an efficient, cross-platform back-end.
 .
 This package contains the transmission-daemon.
 .
 For the associated transmission-remote, see the package
 transmission-cli, or any of the GUI interfaces,
 transmission-remote-gtk, transgui, or tremotesf, all of which can be
 used to control and monitor the daemon either locally or remotely.

Package: libtransmission-dev
Section: libdevel
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}
Description: lightweight BitTorrent client (development library)
 Transmission is a set of lightweight BitTorrent clients (in GUI, CLI
 and daemon form). All its incarnations feature a very simple,
 intuitive interface on top on an efficient, cross-platform back-end.
 .
 This package contains the static library and associated #include
 file.

## transmission 4.1.0~beta5+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16.3 FATAL_ERROR)

cmake_policy(SET CMP0090 NEW)
cmake_policy(SET CMP0092 NEW)
if(POLICY CMP0114)
    cmake_policy(SET CMP0114 NEW)
endif()

# Value should follow latest stable Xcode's RECOMMENDED_MACOSX_DEPLOYMENT_TARGET
set(MACOS_SUPPORT_MINIMUM 11.0)

# The value of this variable should be set prior to the first project() command invocation.
# See: https://cmake.org/cmake/help/latest/variable/CMAKE_OSX_DEPLOYMENT_TARGET.html
if(NOT CMAKE_OSX_DEPLOYMENT_TARGET)
    set(CMAKE_OSX_DEPLOYMENT_TARGET ${MACOS_SUPPORT_MINIMUM}
        CACHE STRING "Minimum macOS version to target for deployment"
        FORCE)
endif()

if(VCPKG_TARGET_ANDROID)
    include(cmake/VcpkgAndroid.cmake)
endif()

project(transmission)

set(TR_THIRD_PARTY_DIR_NAME third-party)
set(TR_THIRD_PARTY_SOURCE_DIR ${PROJECT_SOURCE_DIR}/${TR_THIRD_PARTY_DIR_NAME})
set(TR_THIRD_PARTY_BINARY_DIR ${PROJECT_BINARY_DIR}/${TR_THIRD_PARTY_DIR_NAME})

list(APPEND CMAKE_MODULE_PATH
    "${PROJECT_SOURCE_DIR}/cmake"
    "${TR_THIRD_PARTY_SOURCE_DIR}/rpavlik-cmake-modules")

set(CMAKE_MACOSX_RPATH ON)

include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckLibraryExists)
include(ExternalProject)
include(GNUInstallDirs)
include(TrMacros)

set(CURL_MINIMUM 7.28.0)
set(WOLFSSL_MINIMUM 3.4)
set(DEFLATE_MINIMUM 1.7)
set(EVENT2_MINIMUM 2.1.0)
set(GIOMM_MINIMUM 2.26.0)
set(GLIBMM_MINIMUM 2.60.0)
set(GTKMM3_MINIMUM 3.24.0)
set(GTKMM4_MINIMUM 4.11.1)
set(OPENSSL_MINIMUM 1.1.0)
set(MBEDTLS_MINIMUM 2.7)
set(NPM_MINIMUM 10.2.3) # Node.js 20.10 (eslint-plugin-unicorn)
set(PSL_MINIMUM 0.21.1)
set(QT_MINIMUM 5.15)

option(ENABLE_DAEMON "Build daemon" ON)
tr_auto_option(ENABLE_GTK "Build GTK client" AUTO)
tr_auto_option(ENABLE_QT "Build Qt client" AUTO)
tr_auto_option(ENABLE_MAC "Build Mac client" AUTO)
tr_auto_option(REBUILD_WEB "Rebuild the web client's generated assets. Requires Node.js and network access." OFF)
option(INSTALL_WEB "Install the web client's generated assets." ON)
option(ENABLE_UTILS "Build utils (create, edit, show)" ON)
option(ENABLE_CLI "Build command-line client" OFF)
option(ENABLE_TESTS "Build unit tests" ON)
option(ENABLE_UTP "Build µTP support" ON)
option(ENABLE_WERROR "Treat warnings as errors" OFF)
option(ENABLE_NLS "Enable native language support" ON)
option(INSTALL_DOC "Build/install documentation" ON)
option(INSTALL_LIB "Install the library" OFF)
tr_auto_option(ENABLE_DEPRECATED "Allow deprecated API use of upstream packages, e.g. GTK" AUTO)
tr_auto_option(RUN_CLANG_TIDY "Run clang-tidy on the code" AUTO)
tr_auto_option(USE_SYSTEM_EVENT2 "Use system event2 library" AUTO)
tr_auto_option(USE_SYSTEM_DEFLATE "Use system deflate library" AUTO)
tr_auto_option(USE_SYSTEM_DHT "Use system dht library" AUTO)
tr_auto_option(USE_SYSTEM_MINIUPNPC "Use system miniupnpc library" AUTO)
tr_auto_option(USE_SYSTEM_NATPMP "Use system natpmp library" AUTO)
tr_auto_option(USE_SYSTEM_UTP "Use system utp library" AUTO)
tr_auto_option(USE_SYSTEM_B64 "Use system b64 library" AUTO)
tr_auto_option(USE_SYSTEM_PSL "Use system psl library" AUTO)
tr_auto_option(USE_SYSTEM_CRC32C "Use system crc32c library" AUTO)
tr_list_option(USE_GTK_VERSION "Use specific GTK version" AUTO 3 4)
tr_list_option(USE_QT_VERSION "Use specific Qt version" AUTO 5 6)
tr_list_option(WITH_CRYPTO "Use specified crypto library" AUTO ccrypto mbedtls openssl wolfssl)
tr_auto_option(WITH_INOTIFY "Enable inotify support (on systems that support it)" AUTO)
tr_auto_option(WITH_KQUEUE "Enable kqueue support (on systems that support it)" AUTO)
tr_auto_option(WITH_APPINDICATOR "Use appindicator for system tray icon in GTK client (GTK+ 3 only)" AUTO)
tr_auto_option(WITH_SYSTEMD "Add support for systemd startup notification (on systems that support it)" AUTO)

set(TR_NAME ${PROJECT_NAME})

# major.minor.patch[-[beta.N.]dev]+commit_hash
# dev builds come between releases, e.g. autobuilds from CI

# these should be the only five lines you need to change
set(TR_VERSION_MAJOR "4")
set(TR_VERSION_MINOR "1")
set(TR_VERSION_PATCH "0")
set(TR_VERSION_BETA_NUMBER "5") # empty string for not beta
set(TR_VERSION_DEV FALSE)

# derived from above: release type
if(TR_VERSION_DEV)
    set(TR_NIGHTLY_RELEASE 1)
elseif(NOT "${TR_VERSION_BETA_NUMBER}" STREQUAL "")
    set(TR_BETA_RELEASE 1)
else()
    set(TR_STABLE_RELEASE 1)
endif()

# derived from above: CFBundleVersion
# note: CFBundleVersion only honors 3 numbers, so third number has to hold both patch and beta info.
# 5.0.1-dev     -> 14719.0.100
# 5.0.1-beta.1  -> 14719.0.101
# 5.0.1         -> 14719.0.199
math(EXPR CFBUNDLE_1 "${TR_VERSION_MAJOR} + 14714")
math(EXPR CFBUNDLE_2 "${TR_VERSION_MINOR}")
math(EXPR CFBUNDLE_3 "${TR_VERSION_PATCH} * 100 + 0${TR_STABLE_RELEASE} * 99 + 0${TR_VERSION_BETA_NUMBER}")
set(CFBUNDLE_VERSION "${CFBUNDLE_1}.${CFBUNDLE_2}.${CFBUNDLE_3}")
unset(CFBUNDLE_1)
unset(CFBUNDLE_2)
unset(CFBUNDLE_3)

# derived from above: semver version string. https://semver.org/
# '4.0.0-beta.1'
# '4.0.0-beta.1.dev' (a dev release between beta 1 and 2)
# '4.0.0-beta.2'
# '4.0.0'
set(TR_SEMVER "${TR_VERSION_MAJOR}.${TR_VERSION_MINOR}.${TR_VERSION_PATCH}")
if(TR_VERSION_DEV OR NOT "${TR_VERSION_BETA_NUMBER}" STREQUAL "")
    string(APPEND TR_SEMVER "-")
    if(NOT "${TR_VERSION_BETA_NUMBER}" STREQUAL "")
        string(APPEND TR_SEMVER "beta.${TR_VERSION_BETA_NUMBER}")
    endif()
    if(TR_VERSION_DEV AND NOT "${TR_VERSION_BETA_NUMBER}" STREQUAL "")
        string(APPEND TR_SEMVER ".")
    endif()
    if(TR_VERSION_DEV)
        string(APPEND TR_SEMVER "dev")
    endif()
endif()
set(TR_USER_AGENT_PREFIX "${TR_SEMVER}")

# derived from above: peer-id prefix. https://www.bittorrent.org/beps/bep_0020.html
# chars 4, 5, 6 are major, minor, patch in https://en.wikipedia.org/wiki/Base62
# char 7 is '0' for a stable release, 'B' for a beta release, or 'Z' for a dev build
# '-TR400B-' (4.0.0 Beta)
# '-TR400Z-' (4.0.0 Dev)
# '-TR4000-' (4.0.0)
set(TR_PEER_ID_PREFIX "-TR")
set(BASE62 "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz")
string(SUBSTRING "${BASE62}" "${TR_VERSION_MAJOR}" 1 TMPSTR)
string(APPEND TR_PEER_ID_PREFIX "${TMPSTR}")
string(SUBSTRING "${BASE62}" "${TR_VERSION_MINOR}" 1 TMPSTR)
string(APPEND TR_PEER_ID_PREFIX "${TMPSTR}")
string(SUBSTRING "${BASE62}" "${TR_VERSION_PATCH}" 1 TMPSTR)
string(APPEND TR_PEER_ID_PREFIX "${TMPSTR}")
if(TR_VERSION_DEV)
    string(APPEND TR_PEER_ID_PREFIX "Z")
elseif(NOT "${TR_VERSION_BETA_NUMBER}" STREQUAL "")
    string(APPEND TR_PEER_ID_PREFIX "B")
else()
    string(APPEND TR_PEER_ID_PREFIX "0")
endif()
string(APPEND TR_PEER_ID_PREFIX "-")

set(TR_VCS_REVISION_FILE "${PROJECT_SOURCE_DIR}/REVISION")

## Compiler standard version

if(NOT CMAKE_C_STANDARD)
    set(CMAKE_C_STANDARD 11)
    set(CMAKE_C_STANDARD_REQUIRED ON)
endif()
if(NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 17)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()

if(EXISTS ${PROJECT_SOURCE_DIR}/.git)
    find_package(Git)
endif()

if(NOT "$ENV{JENKINS_URL}" STREQUAL "" AND NOT "$ENV{GIT_COMMIT}" STREQUAL "")
    set(TR_VCS_REVISION "$ENV{GIT_COMMIT}")
elseif(NOT "$ENV{TEAMCITY_PROJECT_NAME}" STREQUAL "" AND NOT "$ENV{BUILD_VCS_NUMBER}" STREQUAL "")
    set(TR_VCS_REVISION "$ENV{BUILD_VCS_NUMBER}")
elseif(GIT_FOUND)
    include(GetGitRevisionDescription)
    get_git_head_revision(TR_REFSPEC TR_VCS_REVISION)
    unset(TR_REFSPEC)
endif()

if("${TR_VCS_REVISION}" STREQUAL "" AND EXISTS "${TR_VCS_REVISION_FILE}")
    file(READ "${TR_VCS_REVISION_FILE}" TR_VCS_REVISION)
endif()

string(STRIP "${TR_VCS_REVISION}" TR_VCS_REVISION)

if(NOT "${TR_VCS_REVISION}" STREQUAL "")
    file(WRITE "${TR_VCS_REVISION_FILE}" "${TR_VCS_REVISION}\n")
else()
    set(TR_VCS_REVISION 0)
    file(REMOVE "${TR_VCS_REVISION_FILE}")
endif()

string(SUBSTRING "${TR_VCS_REVISION}" 0 10 TR_VCS_REVISION)

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

if(WIN32)
    foreach(L C CXX)
        set(CMAKE_${L}_FLAGS "${CMAKE_${L}_FLAGS} -DWIN32")
        # Target version (Vista and up)
        set(CMAKE_${L}_FLAGS "${CMAKE_${L}_FLAGS} -DWINVER=0x0600 -D_WIN32_WINNT=0x0600")
        # Use Unicode API (although we always use W or A names explicitly)
        set(CMAKE_${L}_FLAGS "${CMAKE_${L}_FLAGS} -DUNICODE -D_UNICODE")
        # Ignore various deprecation and security warnings (at least for now)
        set(CMAKE_${L}_FLAGS "${CMAKE_${L}_FLAGS} -D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE -D_SCL_SECURE_NO_WARNINGS -D_WINSOCK_DEPRECATED_NO_WARNINGS")
        if(MSVC)
            # Set source file encoding and execution charset to UTF-8
            set(CMAKE_${L}_FLAGS "${CMAKE_${L}_FLAGS} /utf-8")
            # Reduce noise (at least for now)
            set(CMAKE_${L}_FLAGS "${CMAKE_${L}_FLAGS} /wd4244 /wd4267")
            # Make caching-friendly (store debug info inside object files)
            foreach(T IN ITEMS ${CMAKE_CONFIGURATION_TYPES} ${CMAKE_BUILD_TYPE})
                string(TOUPPER "${T}" T)
                string(REGEX REPLACE "[-/]Z[iI]" "-Z7" CMAKE_${L}_FLAGS_${T} "${CMAKE_${L}_FLAGS_${T}}")
            endforeach()
        endif()

        if(MINGW)
            set(CMAKE_${L}_FLAGS "${CMAKE_${L}_FLAGS} -D__USE_MINGW_ANSI_STDIO=1")
        endif()
    endforeach()
endif()

set(CMAKE_FOLDER "${TR_THIRD_PARTY_DIR_NAME}")

set(SOURCE_ICONS_DIR "${PROJECT_SOURCE_DIR}/icons")

find_package(FastFloat)
find_package(Fmt)
find_package(RapidJSON)
find_package(Small)
find_package(UtfCpp)
find_package(WideInteger)

find_package(Threads)
find_package(PkgConfig QUIET)

find_package(CURL ${CURL_MINIMUM} REQUIRED)

if(ENABLE_DEPRECATED STREQUAL "AUTO")
    if(DEFINED ENV{CI})
        set(ENABLE_DEPRECATED OFF)
    else()
        set(ENABLE_DEPRECATED ON)
    endif()
endif()

set(CRYPTO_PKG "")
if(WITH_CRYPTO STREQUAL "AUTO" OR WITH_CRYPTO STREQUAL "ccrypto")
    tr_get_required_flag(WITH_CRYPTO CCRYPTO_IS_REQUIRED)
    find_path(CCRYPTO_INCLUDE_DIR
        NAMES CommonCrypto/CommonCrypto.h
        ${CCRYPTO_IS_REQUIRED})
    mark_as_advanced(CCRYPTO_INCLUDE_DIR)
    tr_fixup_list_option(WITH_CRYPTO "ccrypto" CCRYPTO_INCLUDE_DIR "AUTO" CCRYPTO_IS_REQUIRED)
    if(WITH_CRYPTO STREQUAL "ccrypto")
        set(CRYPTO_PKG "ccrypto")
        set(CRYPTO_INCLUDE_DIRS)
        set(CRYPTO_LIBRARIES)
    endif()
endif()
if(WITH_CRYPTO STREQUAL "AUTO" OR WITH_CRYPTO STREQUAL "openssl")
    tr_get_required_flag(WITH_CRYPTO OPENSSL_IS_REQUIRED)
    find_package(OpenSSL ${OPENSSL_MINIMUM} ${OPENSSL_IS_REQUIRED})
    tr_fixup_list_option(WITH_CRYPTO "openssl" OPENSSL_FOUND "AUTO" OPENSSL_IS_REQUIRED)
    if(WITH_CRYPTO STREQUAL "openssl")
        set(CRYPTO_PKG "openssl")
        set(CRYPTO_INCLUDE_DIRS ${OPENSSL_INCLUDE_DIR})
        set(CRYPTO_LIBRARIES ${OPENSSL_LIBRARIES})
    endif()
endif()
if(WITH_CRYPTO STREQUAL "AUTO" OR WITH_CRYPTO STREQUAL "wolfssl")
    tr_get_required_flag(WITH_CRYPTO WOLFSSL_IS_REQUIRED)
    find_package(WolfSSL ${WOLFSSL_MINIMUM} ${WOLFSSL_IS_REQUIRED})
    tr_fixup_list_option(WITH_CRYPTO "wolfssl" WOLFSSL_FOUND "AUTO" WOLFSSL_IS_REQUIRED)
    if(WITH_CRYPTO STREQUAL "wolfssl")
        set(CRYPTO_PKG "wolfssl")
        set(CRYPTO_INCLUDE_DIRS ${WOLFSSL_INCLUDE_DIRS})
        set(CRYPTO_LIBRARIES ${WOLFSSL_LIBRARIES})
    endif()
endif()
if(WITH_CRYPTO STREQUAL "AUTO" OR WITH_CRYPTO STREQUAL "mbedtls")
    tr_get_required_flag(WITH_CRYPTO MBEDTLS_IS_REQUIRED)
    find_package(MbedTLS ${MBEDTLS_MINIMUM} ${MBEDTLS_IS_REQUIRED})
    tr_fixup_list_option(WITH_CRYPTO "mbedtls" MBEDTLS_FOUND "AUTO" MBEDTLS_IS_REQUIRED)
    if(WITH_CRYPTO STREQUAL "mbedtls")
        set(CRYPTO_PKG "mbedtls")
        set(CRYPTO_LIBRARIES MbedTLS::mbedtls MbedTLS::mbedcrypto)
    endif()
endif()

# We should have found the library by now
if(CRYPTO_PKG STREQUAL "")
    if(WITH_CRYPTO STREQUAL "AUTO")
        message(FATAL_ERROR "Unable to find any supported crypto library.")
    else()
        message(FATAL_ERROR "Requested crypto library '${WITH_CRYPTO}' is not supported.")

=== libtransmission-app/CMakeLists.txt ===
include(CheckLibraryExists)
include(CheckSymbolExists)

set(LIBNAME ${TR_NAME}-app)

add_library(${LIBNAME} STATIC)
add_library(transmission::app ALIAS ${LIBNAME})

target_sources(${LIBNAME}
    PRIVATE
        app.cc
        app.h
        converters.cc
        converters.h
        display-modes.h
        favicon-cache.h)

target_include_directories(${LIBNAME}
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}/..
        ${CMAKE_CURRENT_BINARY_DIR}/..)

target_link_libraries(${LIBNAME}
    PUBLIC
        fmt::fmt-header-only)

=== debian/changelog ===
transmission (4.1.0~beta5+dfsg-1) unstable; urgency=medium

  [ Alexandre Rossi ]
  * New upstream version 4.1.0~beta5+dfsg
  * avoid compiling with dialect cpp20
  * silence compile message leading to blhc false positive
  * drop useless wolfssl build dependency (Closes: #1123052)
  * d/copyright: update regarding qt icons (removed upstream)
  * update use-system-libs.patch to match upstream candidate

  [ Barak A. Pearlmutter ]
  * d/watch: version 5, github template

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 06 Jan 2026 20:28:28 +0000

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,6 @@
                libevent-dev,
                libgtkmm-4.0-dev (>= 4.11),
                libglibmm-2.68-dev,
-               libwolfssl-dev,
                libminiupnpc-dev,
                libnatpmp-dev,
                libnotify-dev,
@@ -19,6 +18,7 @@
                libfast-float-dev,
                libfmt-dev,
                libgtest-dev,
+               libb64-dev,
                libdeflate-dev,
                libpsl-dev,
                libutfcpp-dev,

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export QT_SELECT=6

%:
	dh $@

# On ENABLE_DEPRECATED=ON:
#      build system makes deprecations failures if $CI is not empty:
#      force enable of deprecations (e.g. GTK)
override_dh_auto_configure:
	dh_auto_configure --				\
		-DINSTALL_LIB=ON			\
		-DUSE_SYSTEM_GTEST=ON			\
		-DENABLE_CLI=ON				\
		-DENABLE_GTK=ON				\
		-DENABLE_QT=ON				\
		-DUSE_QT_VERSION=$(QT_SELECT)		\
		-DENABLE_DEPRECATED=ON \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo

%.css: %.scss
	rsass $< > $@

WEBUI_SOURCES := $(wildcard web/src/*.js)

.PHONY: webui

webui: web/assets/css/transmission-app.css $(WEBUI_SOURCES)
	mkdir -p web/node_modules
	ln -sf /usr/share/nodejs/fast-deep-equal web/node_modules/
	cd web && esbuild \
		--allow-overwrite \
		--bundle \
		--legal-comments=external \
		--loader:.png=dataurl \
		--loader:.svg=dataurl \
		--minify \
		--sourcemap \
		--outfile=public_html/transmission-app.js \
		src/main.js

execute_before_dh_auto_build: webui

execute_after_dh_auto_install:
	@echo "remove extra license file"
	-rm --verbose debian/tmp/usr/share/doc/transmission/COPYING

override_dh_installdocs:
	dh_installdocs --link-doc=transmission-common

=== debian/watch ===
Version: 5
Template: GitHub
Owner: @PACKAGE@
Project: @PACKAGE@
Dversion-Mangle: s/\+dfsg$//
Uversion-Mangle: s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/
Repacksuffix: +dfsg

## transmission 4.1.0%2Bdfsg

=== debian/rules ===
--- 
+++ 
@@ -20,6 +20,8 @@
 		-DUSE_QT_VERSION=$(QT_SELECT)		\
 		-DENABLE_DEPRECATED=ON \
 		-DCMAKE_BUILD_TYPE=RelWithDebInfo
+	# silence blhc false positive on missing flags for compiler test
+	echo "blhc: ignore-line-regexp: .*CMakeCXXCompilerABI\.cpp.*"
 
 %.css: %.scss
 	rsass $< > $@

## transmission 4.1.0%2Bmint1%2Bgigi

=== tests/gtest/CMakeLists.txt ===
set(GTEST_ROOT_DIR ${TR_THIRD_PARTY_SOURCE_DIR}/googletest/googletest)

add_library(gtestall STATIC)

# GTest 1.12 triggers nullptr warnings in gcc 13
set(CACHE_ID "${CMAKE_CXX_COMPILER_ID}_CXX_HAS-Wnull-dereference")
string(TOLOWER "${CACHE_ID}" CACHE_ID)
check_c_compiler_flag(-Wnull-dereference ${CACHE_ID})
if(${CACHE_ID})
    target_compile_options(gtestall PRIVATE -Wno-null-dereference)
endif()

target_sources(gtestall
    PRIVATE
        /usr/src/googletest/googletest/src/gtest-all.cc
        /usr/src/googletest/googletest/src/gtest_main.cc)

set_property(
    TARGET gtestall
    PROPERTY FOLDER "${TR_THIRD_PARTY_DIR_NAME}")

target_include_directories(gtestall SYSTEM
    PRIVATE
        /usr/src/googletest/googletest
    PUBLIC
        /usr/src/googletest/googletest/include)

=== third-party/small/dev-tools/CMakeLists.txt ===
#
# Copyright (c) 2022 alandefreitas (alandefreitas@gmail.com)
#
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt
#


add_subdirectory(linter)

=== third-party/rpavlik-cmake-modules/nested_targets/DCubed/d3ew_scene/CMakeLists.txt ===
# - Build the DCubed wrapper library d3ew_scene as a part of your solution.
#
# Original Author:
# 2009-2010 Ryan Pavlik <rpavlik@iastate.edu> <abiryan@ryand.net>
# http://academic.cleardefinition.com
# Iowa State University HCI Graduate Program/VRAC
#
# Copyright 2009-2010, Iowa State University
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file ../../LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)
# SPDX-License-Identifier: BSL-1.0


set(SOURCES)
foreach(filename ansi.hxx
	body.hxx
	d3ew_clap_data.cpp
	d3ew_clap_data.hxx
	d3ew_new.hxx
	d3ew_stack.cpp
	d3ew_stack.hxx
	debload.hxx
	edge.cpp
	edge.hxx
	ehlc_timer.cpp
	ehlc_timer.hxx
	face.cpp
	face.hxx
	frustum.cpp
	frustum.hxx
	hldeb.hxx
	hljournal.hxx
	hlm_cdm_dummies.cpp
	hltable.hxx
	hltabledef.hxx
	journalw.cpp
	journalw.hxx
	modeller.cpp
	modeller.hxx
	nowarn.hxx
	scene.cpp
	scene.hxx
	scene_build.cpp
	scene_edge.cpp
	scene_face.cpp
	scene_misc.cpp
	scene_node.cpp
	scene_node.hxx
	scene_table.cpp
	scene_table.hxx
	secure_c.hxx
	segment.cpp
	segment.hxx
	table_dec.hxx
	wrapper.cpp
	wrapper_new.cpp)
	list(APPEND SOURCES "${DCUBED_WRAPPER_INCLUDE_DIR}/d3ew_scene/${filename}")
endforeach()
add_library(dcubed_wrapper_d3ew_scene_nested_target
	STATIC
	EXCLUDE_FROM_ALL
	${SOURCES})

set_property(TARGET
	dcubed_wrapper_d3ew_scene_nested_target
	PROPERTY
	PROJECT_LABEL
	"DCubed d3ew_scene Wrapper Library")

=== debian/control ===
--- 
+++ 
@@ -9,15 +9,16 @@
                libayatana-appindicator3-dev,
                libcurl4-openssl-dev | libcurl4-dev | libcurl-dev,
                libevent-dev,
-               libgtkmm-4.0-dev (>= 4.11),
-               libglibmm-2.68-dev,
+               libgtkmm-3.0-dev,
+               libglibmm-2.4-dev,
+               libwolfssl-dev,
                libminiupnpc-dev,
                libnatpmp-dev,
                libnotify-dev,
                libssl-dev,
                libfast-float-dev,
                libfmt-dev,
-               libgtest-dev,
+               googletest,
                libb64-dev,
                libdeflate-dev,
                libpsl-dev,
@@ -30,9 +31,10 @@
                libqt6svg6-dev,
                zlib1g-dev,
                esbuild,
-               node-fast-deep-equal,
+               node-lodash-packages,
                rsass,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.0
+Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/transmission
 Vcs-Git: https://salsa.debian.org/debian/transmission.git
 Homepage: https://transmissionbt.com/
